Index: src/edu/ucsb/nceas/metacat/MetaCatServlet.java
===================================================================
--- src/edu/ucsb/nceas/metacat/MetaCatServlet.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/MetaCatServlet.java	(revision 4080)
@@ -1,4 +1,4 @@
-/**
+ /**
  *  '$RCSfile$'
  *    Purpose: A Class that implements a metadata catalog as a java Servlet
  *  Copyright: 2006 Regents of the University of California and the
@@ -32,7 +32,6 @@
 import java.io.FileReader;
 import java.io.IOException;
 import java.io.PrintWriter;
-import java.io.Reader;
 import java.io.StringReader;
 import java.net.MalformedURLException;
 import java.net.URL;
@@ -69,10 +68,19 @@
 import com.oreilly.servlet.multipart.ParamPart;
 import com.oreilly.servlet.multipart.Part;
 
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.metacat.service.ServiceException;
+import edu.ucsb.nceas.metacat.service.SessionService;
+import edu.ucsb.nceas.metacat.service.SkinPropertyService;
 import edu.ucsb.nceas.metacat.spatial.SpatialHarvester;
 import edu.ucsb.nceas.metacat.spatial.SpatialQuery;
-import edu.ucsb.nceas.utilities.Options;
-import edu.ucsb.nceas.utilities.OptionsMetadata;
+import edu.ucsb.nceas.metacat.util.LDAPUtil;
+import edu.ucsb.nceas.metacat.util.MetaCatUtil;
+import edu.ucsb.nceas.metacat.util.RequestUtil;
+import edu.ucsb.nceas.metacat.util.SessionData;
+import edu.ucsb.nceas.metacat.util.UtilException;
+import edu.ucsb.nceas.utilities.GeneralPropertyException;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
 
 /**
  * A metadata catalog server implemented as a Java Servlet
@@ -124,8 +132,9 @@
  * reflect this information.
  */
 public class MetaCatServlet extends HttpServlet {
-    private static Hashtable sessionHash = new Hashtable();
-    private Timer timer = null;
+
+	private static final long serialVersionUID = 1L;
+	private Timer timer = null;
     private static boolean sitemapScheduled;
     
     // Constants -- these should be final in a servlet
@@ -140,7 +149,6 @@
     public static final String EML2KEYWORD = ":eml";
     public static final String XMLFORMAT = "xml";
     private static final String CONFIG_DIR = "WEB-INF";
-    private static final String CONFIG_NAME = "metacat.properties";
     private static final String FALSE = "false";
     private static final String TRUE  = "true";
     
@@ -148,46 +156,42 @@
      * Initialize the servlet by creating appropriate database connections
      */
     public void init(ServletConfig config) throws ServletException {
-        try {
+    	Logger logMetacat = Logger.getLogger(MetaCatServlet.class);
+    	try {
             super.init(config);
-            Logger logMetacat = Logger.getLogger(MetaCatServlet.class);
             
             ServletContext context = config.getServletContext();
-            
+             
             // Initialize the properties file for our options
             String dirPath = context.getRealPath(CONFIG_DIR);
-            File propertyFile = new File(dirPath, CONFIG_NAME);
             
             String LOG_CONFIG_NAME = dirPath + "/log4j.properties";
             PropertyConfigurator.configureAndWatch(LOG_CONFIG_NAME);
             
-            Options options = null;
-            try {
-                options = Options.initialize(propertyFile);
-            } catch (IOException ioe) {
-                logMetacat.error("Error in loading options: "
-                        + ioe.getMessage());
-            }
+            PropertyService propertyService = PropertyService.getInstance(context);
+            logMetacat.debug("PropertyService singleton created " + propertyService);
             
+            SkinPropertyService skinPropertyService = SkinPropertyService.getInstance(context);
+            logMetacat.debug("PropertyService singleton created " + skinPropertyService);
+            
+            SessionService sessionService = SessionService.getInstance();
+            logMetacat.debug("SessionService singleton created " + sessionService);
+            
             // Check if the servlet was configured, and if not stop the
             // initialization and skip to the configuration web form when
             // metacat is called
-            boolean configured = options.getOption("configured").equals("true");
-            if (!configured) {
-                logMetacat.info("Options configured: " + configured);
-                return;
-            }
+            if (!MetaCatUtil.isMetacatConfigured()) {
+            	return;
+            }       
             
-            MetaCatUtil util = new MetaCatUtil();
-            
             //initialize DBConnection pool
             DBConnectionPool connPool = DBConnectionPool.getInstance();
+            logMetacat.debug("DBConnection pool initialized: "+ connPool.toString());
             
-            //check if eml201 document were corrected or not.
-            // if not, correct eml201 documents.
+            //check if eml201 document were corrected or not. if not, correct eml201 documents.
             //Before Metacat 1.8.1, metacat uses tag RELEASE_EML_2_0_1_UPDATE_6 as eml 
             //schema, which accidentily points to wrong version of eml-resource.xsd.
-            String correctedEML201Doc = MetaCatUtil.getOption("eml201_document_corrected");
+            String correctedEML201Doc = PropertyService.getProperty("eml201_document_corrected");
             if (correctedEML201Doc != null && correctedEML201Doc.equals(FALSE))
             {
             	logMetacat.info("===Start to correct eml201 documents");
@@ -195,7 +199,7 @@
             	boolean success = correct.run();
             	if (success)
             	{
-            	     MetaCatUtil.setOption("eml201_document_corrected", TRUE);
+            		PropertyService.setProperty("eml201_document_corrected", TRUE);
             	}
             	logMetacat.info("====Finish to correct eml201 documents");
             }
@@ -209,8 +213,8 @@
             
             // start the IndexingThread if indexingTimerTaskTime more than 0.
             // It will index all the documents not yet indexed in the database
-            int indexingTimerTaskTime = Integer.parseInt(MetaCatUtil.getOption("indexingTimerTaskTime"));
-            int delayTime = Integer.parseInt(MetaCatUtil.getOption("indexingInitialDelay"));
+            int indexingTimerTaskTime = Integer.parseInt(PropertyService.getProperty("database.indexingTimerTaskTime"));
+            int delayTime = Integer.parseInt(PropertyService.getProperty("database.indexingInitialDelay"));
             
             if(indexingTimerTaskTime > 0){
                 timer = new Timer();
@@ -218,7 +222,7 @@
             }
             
             // read the config files:
-            Vector skins = MetaCatUtil.getOptionList(MetaCatUtil.getOption("skinconfigfiles"));
+            Vector<String> skins = MetaCatUtil.getOptionList(PropertyService.getProperty("skin.names"));
             String skinName, skinDirPath = null;
             File skinPropertyFile = null;
             
@@ -244,8 +248,8 @@
              *  If spatial option is turned on and set to regenerate the
              *  spatial cache on restart, trigger the harvester regeneratation method
              */
-            if ( MetaCatUtil.getOption("runSpatialOption").equals("true") &&
-                    MetaCatUtil.getOption("regenerateCacheOnRestart").equals("true") ) {
+            if ( PropertyService.getProperty("runSpatialOption").equals("true") &&
+                    PropertyService.getProperty("regenerateCacheOnRestart").equals("true") ) {
                 
                 // Begin timer
                 long before = System.currentTimeMillis();
@@ -258,7 +262,7 @@
                 
                 // After running the first time, we want to to set regenerateCacheOnRestart to false
                 // so that it does not regenerate the cache every time tomcat is restarted
-                MetaCatUtil.setOption("regenerateCacheOnRestart","false");
+                PropertyService.setProperty("regenerateCacheOnRestart","false");
                 
                 // End timer
                 long after = System.currentTimeMillis();
@@ -270,19 +274,30 @@
             
             sitemapScheduled = false;
             
-            logMetacat.warn("Metacat (" + Version.getVersion()
+            logMetacat.warn("Metacat (" + MetaCatVersion.getVersionID()
             + ") initialized.");
             
-        } catch (ServletException ex) {
-            throw ex;
         } catch (SQLException e) {
-            Logger logMetacat = Logger.getLogger(MetaCatServlet.class);
-            logMetacat.error("Error in MetacatServlet.init: "
-                    + e.getMessage());
+        	String errorMessage = 
+        		"SQL problem while intializing MetaCat Servlet: " + e.getMessage();
+            logMetacat.error(errorMessage);
+            throw new ServletException(errorMessage);
+        } catch (ServiceException se) {
+        	String errorMessage = 
+        		"Service problem while intializing MetaCat Servlet: " + se.getMessage();
+            logMetacat.error(errorMessage);
+            throw new ServletException(errorMessage);
         } catch (IOException ie) {
-            Logger logMetacat = Logger.getLogger(MetaCatServlet.class);
-            logMetacat.error("Error in MetacatServlet.init: "
-                    + ie.getMessage());
+           	String errorMessage = 
+           		"IO problem while intializing MetaCat Servlet: "+ ie.getMessage();
+           	logMetacat.error(errorMessage);
+           	throw new ServletException(errorMessage);
+        } catch (GeneralPropertyException gpe) {
+        	String errorMessage = 
+        		"Could not retrieve property while intializing MetaCat Servlet: " 
+        		+ gpe.getMessage();
+        	logMetacat.error(errorMessage);
+            throw new ServletException(errorMessage);
         }
     }
     
@@ -318,9 +333,20 @@
      */
     private void checkIndexPaths() {
         Logger logMetacat = Logger.getLogger(MetaCatServlet.class);
-        MetaCatUtil.pathsForIndexing
-                = MetaCatUtil.getOptionList(MetaCatUtil.getOption("indexPaths"));
         
+        try {
+        	MetaCatUtil.pathsForIndexing
+                = MetaCatUtil.getOptionList(PropertyService.getProperty("indexPaths"));
+        
+        	MetaCatUtil.pathsForIndexing = 
+        		MetaCatUtil.getOptionList(PropertyService.getProperty("indexPaths"));
+        }
+        catch (PropertyNotFoundException pnfe) {
+        	MetaCatUtil.pathsForIndexing = null;
+            logMetacat.error("Could not find index paths.  Setting " 
+            		+ "MetaCatUtil.pathsForIndexing to null: " + pnfe.getMessage());
+        }
+        
         if (MetaCatUtil.pathsForIndexing != null) {
             
             logMetacat.debug("Indexing paths specified in metacat.properties....");
